Package ghidra.program.model.symbol

# Interface SymbolTable

All Known Implementing Classes:
  `SymbolManager`

public interface SymbolTable
A SymbolTable manages the Symbols defined in a program.

A Symbol is an association between an Address, a String name. In addition, symbols may have one or more References.

A Reference is a 4-tuple of a source address, destination address, type, and either a mnemonic or operand index.

Any address in a program can have more than one symbol associated to it. At any given time, one and only one symbol will be designated as the primary.

A symbol can be either global or local. Local symbols belong to some namespace other than the global namespace.

Label and Function symbols do not have to have unique names with a namespace. All other symbols must be unique within a namespace and be unique with all other symbols that must be unique. In other words, you can have several functions named "foo" and several labels named "foo" in the same namespace. But you can't have a class named "foo" and a namespace named "foo". But you can have a class named "foo" and many functions and labels named "foo" all in the same namespace.

A symbol can also be designated as dynamic. Which means the name is generated on-the-fly by the system based on its context.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addExternalEntryPoint(Address addr)`
  Add a memory address to the external entry points.
  `GhidraClass`
  `convertNamespaceToClass(Namespace namespace)`
  Convert the given namespace to a class namespace
  `GhidraClass`
  `createClass(Namespace parent, String name, SourceType source)`
  Create a class namespace in the given parent namespace
  `Library`
  `createExternalLibrary(String name, SourceType source)`
  Create a library namespace with the given name
  `Symbol`
  `createLabel(Address addr, String name, Namespace namespace, SourceType source)`
  Create a label symbol with the given name and namespace associated to the given memory address.
  `Symbol`
  `createLabel(Address addr, String name, SourceType source)`
  Create a label symbol with the given name in the global namespace and associated to the given memory address.
  `Namespace`
  `createNameSpace(Namespace parent, String name, SourceType source)`
  Create a new namespace
  `SymbolIterator`
  `getAllSymbols(boolean includeDynamicSymbols)`
  Get all of the symbols, optionally including dynamic symbols
  `SymbolIterator`
  `getChildren(Symbol parentSymbol)`
  Get all symbols that have the given parent symbol
  `Iterator<GhidraClass>`
  `getClassNamespaces()`
  Get all class namespaces defined within the program, in no particular order
  `Symbol`
  `getClassSymbol(String name, Namespace namespace)`
  Get the class symbol with the given name in the given namespace
  `SymbolIterator`
  `getDefinedSymbols()`
  Get all defined symbols in no particular order.
  `long`
  `getDynamicSymbolID(Address addr)`
  Get the unique symbol ID for a dynamic symbol at the specified address
  `AddressIterator`
  `getExternalEntryPointIterator()`
  Get the external entry points (addresses)
  `Symbol`
  `getExternalSymbol(String name)`
  Get the external symbol with the given name.
  `SymbolIterator`
  `getExternalSymbols()`
  Get all defined external symbols in no particular order
  `SymbolIterator`
  `getExternalSymbols(String name)`
  Get all the external symbols with the given name
  `Symbol`
  `getGlobalSymbol(String name, Address addr)`
  Get the global symbol with the given name and address.
  `List<Symbol>`
  `getGlobalSymbols(String name)`
  Get a list of all global symbols with the given name.
  `Iterator<LabelHistory>`
  `getLabelHistory()`
  Get the complete label history of the program
  `LabelHistory[]`
  `getLabelHistory(Address addr)`
  Get the label history for the given address
  `List<Symbol>`
  `getLabelOrFunctionSymbols(String name, Namespace namespace)`
  Get all the label or function symbols that have the given name in the given parent namespace.
  `Symbol`
  `getLibrarySymbol(String name)`
  Get the library symbol with the given name
  `Symbol`
  `getLocalVariableSymbol(String name, Namespace namespace)`
  Get the local variable symbol with the given name in the given namespace
  `Namespace`
  `getNamespace(Address addr)`
  Get the deepest namespace containing the given address
  `Namespace`
  `getNamespace(String name, Namespace namespace)`
  Get the namespace with the given name in the given parent namespace.
  `Symbol`
  `getNamespaceSymbol(String name, Namespace namespace)`
  Get a generic namespace symbol with the given name in the given parent namespace
  `int`
  `getNumSymbols()`
  Get the total number of symbols in the table
  `Namespace`
  `getOrCreateNameSpace(Namespace parent, String name, SourceType source)`
  Get or create the namespace with the given name in the given parent
  `Symbol`
  `getParameterSymbol(String name, Namespace namespace)`
  Get the parameter symbol with the given name in the given namespace
  `Symbol`
  `getPrimarySymbol(Address addr)`
  Get the primary label or function symbol at the given address
  `SymbolIterator`
  `getPrimarySymbolIterator(boolean forward)`
  Get all primary label and function symbols defined within program memory address.
  `SymbolIterator`
  `getPrimarySymbolIterator(Address startAddr, boolean forward)`
  Get all primary label and function symbols starting at the specified memory address through to the program's maximum memory address.
  `SymbolIterator`
  `getPrimarySymbolIterator(AddressSetView addressSet, boolean forward)`
  Get primary label and function symbols within the given address set.
  `Symbol`
  `getSymbol(long symbolID)`
  Get the symbol for the given symbol ID.
  `Symbol`
  `getSymbol(Reference ref)`
  Get the symbol that a given reference associates
  `Symbol`
  `getSymbol(String name, Address addr, Namespace namespace)`
  Get the symbol with the given name, address, and namespace.
  `SymbolIterator`
  `getSymbolIterator()`
  Get all label symbols
  `SymbolIterator`
  `getSymbolIterator(boolean forward)`
  Get all the symbols defined with program memory.
  `SymbolIterator`
  `getSymbolIterator(Address startAddr, boolean forward)`
  Get all the symbols starting at the specified memory address.
  `SymbolIterator`
  `getSymbolIterator(String searchStr, boolean caseSensitive)`
  Get an iterator over all symbols that match the given query
  `SymbolIterator`
  `getSymbols(long namespaceID)`
  Get an iterator over all the symbols in the given namespace
  `Symbol[]`
  `getSymbols(Address addr)`
  Get all the symbols at the given address.
  `SymbolIterator`
  `getSymbols(AddressSetView addressSet, SymbolType type, boolean forward)`
  Get all the symbols of the given type within the given address set.
  `SymbolIterator`
  `getSymbols(Namespace namespace)`
  Get an iterator over all the symbols in the given namespace
  `SymbolIterator`
  `getSymbols(String name)`
  Get all the symbols with the given name
  `List<Symbol>`
  `getSymbols(String name, Namespace namespace)`
  Get a list of all symbols with the given name in the given parent namespace.
  `SymbolIterator`
  `getSymbolsAsIterator(Address addr)`
  Get an iterator over the symbols at the given address.
  `Symbol[]`
  `getUserSymbols(Address addr)`
  Get an array of defined symbols at the given address (i.e., those with database record).
  `Symbol`
  `getVariableSymbol(String name, Function function)`
  Get a symbol that is either a parameter or local variable.
  `boolean`
  `hasLabelHistory(Address addr)`
  Check if there is a history of label changes at the given address
  `boolean`
  `hasSymbol(Address addr)`
  Check if there exists any symbol at the given address
  `boolean`
  `isExternalEntryPoint(Address addr)`
  Check if the given address is an external entry point
  `void`
  `removeExternalEntryPoint(Address addr)`
  Remove an address from the external entry points
  `boolean`
  `removeSymbolSpecial(Symbol sym)`
  Removes the specified symbol from the symbol table.
  `SymbolIterator`
  `scanSymbolsByName(String startName)`
  Scan symbols lexicographically by name

- ## Method Details

  - ### createLabel

    Symbol createLabel(Address addr, String name, SourceType source) throws InvalidInputException
    Create a label symbol with the given name in the global namespace and associated to the given memory address. (see `Address.isMemoryAddress()`).

    The new symbol will be of type `SymbolType.LABEL` or `SymbolType.FUNCTION` if a default function symbol currently exists at the address. If a default function symbol exists at the specified address the function symbol will be renamed and returned. Label and function symbols do not need to be unique across multiple addresses. However, if a global symbol at the specified address already has the specified name it will be returned without changing the source type. If this is the first non-dynamic symbol defined for the address it becomes the primary symbol.

    Parameters:
      `addr` - the memory address at which to create a symbol
      `name` - the name of the symbol
      `source` - the source of this symbol. In general, a source of `SourceType.DEFAULT` should never be specified using this method.
    Returns:
      new labe or function symbol
    Throws:
      `InvalidInputException` - if name contains white space, is zero length, or is null for non-default source
      `IllegalArgumentException` - if `SourceType.DEFAULT` is improperly specified, or a non-memory address.

  - ### createLabel

    Symbol createLabel(Address addr, String name, Namespace namespace, SourceType source) throws InvalidInputException
    Create a label symbol with the given name and namespace associated to the given memory address. (see `Address.isMemoryAddress()`).

    The new symbol will be of type `SymbolType.LABEL` or `SymbolType.FUNCTION` if a default function symbol currently exists at the address. If a default function symbol exists at the specified address the function symbol will be renamed and returned. Label and function symbols do not need to be unique across multiple addresses or namespaces. However, if a symbol at the specified address already has the specified name and namespace it will be returned without changing the source type. If this is the first non-dynamic symbol defined for the address it becomes the primary symbol.

    Parameters:
      `addr` - the address at which to create a symbol
      `name` - the name of the symbol
      `namespace` - the parent namespace of the symbol, or null for the global namespace.
      `source` - the source of this symbol. In general, a source of `SourceType.DEFAULT` should never be specified using this method.
    Returns:
      new label or function symbol
    Throws:
      `InvalidInputException` - if name contains white space, is zero length, or is null for non-default source. Also thrown if invalid parent namespace is specified.
      `IllegalArgumentException` - if `SourceType.DEFAULT` is improperly specified, or a non-memory address, or if the given parent namespace is from a different program than that of this symbol table.

  - ### removeSymbolSpecial

    boolean removeSymbolSpecial(Symbol sym)
    Removes the specified symbol from the symbol table.

    If removing any non-function symbol, the behavior will be the same as invoking `Symbol.delete()` on the symbol. Use of this method for non-function symbols is discouraged.

    WARNING! If removing a function symbol, the behavior differs from directly invoking `Symbol.delete()` on the function symbol. When removing a function symbol this method has the following behavior:

    - If the function is a default symbol (e.g., FUN_12345678) this method has no effect and will return false.
    - If no other labels exist at the function entry, the function will be renamed to the default function name.
    - If another label does exist at the function entry point, that label will be removed, and the function will be renamed to that label's name.

    Any reference bound to a removed symbol will lose that symbol specific binding.

    Parameters:
      `sym` - the symbol to be removed.
    Returns:
      true if a symbol is removed, false if not or in case of failure

  - ### getSymbol

    Symbol getSymbol(long symbolID)
    Get the symbol for the given symbol ID.
    Parameters:
      `symbolID` - the id of the symbol to be retrieved
    Returns:
      null if there is no symbol with the given ID

  - ### getSymbol

    Symbol getSymbol(String name, Address addr, Namespace namespace)
    Get the symbol with the given name, address, and namespace.

    Note that for a symbol to be uniquely specified, all these parameters are required. Any method that queries for symbols using just one or two of these parameters will return only the first match.

    NOTE: This method will not return a default thunk (i.e., thunk function symbol with default source type) since it mirrors the name and parent namespace of the function it thunks.

    Parameters:
      `name` - the name of the symbol to retrieve
      `addr` - the address of the symbol to retrieve
      `namespace` - the namespace of the symbol to retrieve. May be null which indicates the global namespace.
    Returns:
      the symbol which matches the specified criteria or null if not found
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table
    See Also:
      - `for a convenience method if the namespace is the global namespace.`

  - ### getGlobalSymbol

    Symbol getGlobalSymbol(String name, Address addr)
    Get the global symbol with the given name and address.

    Note that this results in a single Symbol because of an additional restriction that allows only one symbol with a given name at the same address and namespace (in this case the global namespace).

    This is just a convenience method for `getSymbol(String, Address, Namespace)` where the namespace is the global namespace.

    NOTE: This method will not return a default thunk (i.e., thunk function symbol with default source type) since it mirrors the name and parent namespace of the function it thunks.

    Parameters:
      `name` - the name of the symbol to retrieve
      `addr` - the address of the symbol to retrieve
    Returns:
      the symbol which matches the specified criteria in the global namespace or null if not found
    See Also:
      - `getSymbol(String, Address, Namespace)`

  - ### getGlobalSymbols

    List<Symbol> getGlobalSymbols(String name)
    Get a list of all global symbols with the given name. Matches against dynamic label symbols will be included.

    NOTE: This method will not return default thunks (i.e., thunk function symbol with default source type).

    Parameters:
      `name` - the name of the symbols to retrieve
    Returns:
      a list of all global symbols with the given name

  - ### getLabelOrFunctionSymbols

    List<Symbol> getLabelOrFunctionSymbols(String name, Namespace namespace)
    Get all the label or function symbols that have the given name in the given parent namespace. If the global namespace is specified matches against dynamic label symbols will be included.

    NOTE: If a function namespace is specified default parameter and local variable names will be included. If an external library or namespace is specified default external label/function symbols will be included.

    NOTE: This method will not return a default thunk (i.e., thunk function symbol with default source type) since it mirrors the name and parent namespace of the function it thunks.

    Parameters:
      `name` - the name of the symbols to search for
      `namespace` - the namespace to search. If null, then the global namespace is assumed.
    Returns:
      a list of all the label or function symbols with the given name in the given parent namespace
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table

  - ### getNamespaceSymbol

    Symbol getNamespaceSymbol(String name, Namespace namespace)
    Get a generic namespace symbol with the given name in the given parent namespace
    Parameters:
      `name` - the name of the namespace symbol to retrieve
      `namespace` - the namespace containing the symbol to retrieve
    Returns:
      the symbol, or null
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table

  - ### getLibrarySymbol

    Symbol getLibrarySymbol(String name)
    Get the library symbol with the given name
    Parameters:
      `name` - the name of the library symbol to retrieve
    Returns:
      the library symbol with the given name

  - ### getClassSymbol

    Symbol getClassSymbol(String name, Namespace namespace)
    Get the class symbol with the given name in the given namespace
    Parameters:
      `name` - the name of the class
      `namespace` - the parent namespace to search for the class
    Returns:
      the class symbol with the given name in the given namespace
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table

  - ### getParameterSymbol

    Symbol getParameterSymbol(String name, Namespace namespace)
    Get the parameter symbol with the given name in the given namespace
    Parameters:
      `name` - the name of the parameter
      `namespace` - the namespace (function) to search for the class
    Returns:
      the parameter symbol with the given name in the given namespace
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table

  - ### getLocalVariableSymbol

    Symbol getLocalVariableSymbol(String name, Namespace namespace)
    Get the local variable symbol with the given name in the given namespace
    Parameters:
      `name` - the name of the local variable
      `namespace` - the parent namespace (function) to search for the local variable
    Returns:
      the local variable symbol with the given name in the given namespace
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table

  - ### getSymbols

    List<Symbol> getSymbols(String name, Namespace namespace)
    Get a list of all symbols with the given name in the given parent namespace. If the global namespace is specified matches against dynamic label symbols will be included.

    NOTE: If a function namespace is specified default parameter and local variable names will be included. If an external library or namespace is specified default external label/function symbols will be included.

    NOTE: The resulting iterator will not return default thunks (i.e., thunk function symbol with default source type).

    Parameters:
      `name` - the name of the symbols to retrieve
      `namespace` - the namespace to search for symbols
    Returns:
      a list of symbols which satisfy specified criteria
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table

  - ### getVariableSymbol

    Symbol getVariableSymbol(String name, Function function)
    Get a symbol that is either a parameter or local variable.

    There can be only one because these symbol types have a unique name requirement.

    Parameters:
      `name` - the name of the variable
      `function` - the function to search
    Returns:
      a parameter or local variable symbol with the given name

  - ### getNamespace

    Namespace getNamespace(String name, Namespace namespace)
    Get the namespace with the given name in the given parent namespace.

    The returned namespace can be a generic namespace (`SymbolType.NAMESPACE`, `NamespaceSymbol`), class (`SymbolType.CLASS`, `ClassSymbol`),or library (`SymbolType.LIBRARY`, `LibrarySymbol`), but not a function.

    There can be only one because these symbol types have a unique name requirement within their parent namespace.

    Parameters:
      `name` - the name of the namespace to be retrieved
      `namespace` - the parent namespace of the namespace to be retrieved
    Returns:
      the namespace with the given name in the given parent namespace
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table

  - ### getSymbols

    SymbolIterator getSymbols(String name)
    Get all the symbols with the given name

    NOTE: The resulting iterator will not return default thunks (i.e., thunk function symbol with default source type). It will also not work for default local variables and parameters.

    Parameters:
      `name` - the name of symbols to search for
    Returns:
      an iterator over symbols with the given name

  - ### getAllSymbols

    SymbolIterator getAllSymbols(boolean includeDynamicSymbols)
    Get all of the symbols, optionally including dynamic symbols
    Parameters:
      `includeDynamicSymbols` - if true, the iterator will include dynamic symbols
    Returns:
      an iterator over the symbols

  - ### getSymbol

    Symbol getSymbol(Reference ref)
    Get the symbol that a given reference associates
    Parameters:
      `ref` - the reference for the associated symbol
    Returns:
      the associated symbol

  - ### getPrimarySymbol

    Symbol getPrimarySymbol(Address addr)
    Get the primary label or function symbol at the given address

    This method will return null if the address specified is neither a memory address nor an external address.

    Parameters:
      `addr` - the address of the symbol
    Returns:
      the symbol, or null if no symbol is at the address

  - ### getSymbols

    Symbol[] getSymbols(Address addr)
    Get all the symbols at the given address. This method will include a dynamic memory symbol if one exists at the specified address.

    For a memory address the primary symbol will be returned at array index 0. WARNING! Use of this method with non-memory addresses is discouraged. Example: Variable address could be used multiple times by many functions.

    NOTE: unless all the symbols are needed at once, and a dynamic symbol can be ignored, consider using `getSymbolsAsIterator(Address)` instead.

    Parameters:
      `addr` - the address of the symbols
    Returns:
      an array, possibly empty, of the symbols at the given address
    See Also:
      - `getSymbolsAsIterator(Address)`

  - ### getSymbolsAsIterator

    SymbolIterator getSymbolsAsIterator(Address addr)
    Get an iterator over the symbols at the given address. Any dynamic symbol at the address will be excluded.

    Use this instead of `getSymbols(Address)` when you do not need to get all symbols, but rather are searching for a particular symbol. This method prevents all symbols at the given address from being loaded up front.

    Parameters:
      `addr` - the address of the symbols
    Returns:
      an iterator over the symbols at the given address
    See Also:
      - `getSymbols(Address)`

  - ### getUserSymbols

    Symbol[] getUserSymbols(Address addr)
    Get an array of defined symbols at the given address (i.e., those with database record). Any dynamic memory symbol at the address will be excluded.

    WARNING! Use of this method with non-memory addresses is discouraged. Example: Variable address could be used multiple times by many functions.

    NOTE: unless all the symbols are needed at once, consider using `getSymbolsAsIterator(Address)` instead.

    Parameters:
      `addr` - the address of the symbols
    Returns:
      an array, possibly empty, of the symbols

  - ### getSymbols

    SymbolIterator getSymbols(Namespace namespace)
    Get an iterator over all the symbols in the given namespace

    NOTE: The resulting iterator will not return default thunks (i.e., thunk function symbol with default source type).

    Parameters:
      `namespace` - the namespace to search for symbols
    Returns:
      an iterator over the symbols
    Throws:
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table

  - ### getSymbols

    SymbolIterator getSymbols(long namespaceID)
    Get an iterator over all the symbols in the given namespace

    NOTE: The resulting iterator will not return default thunks (i.e., thunk function symbol with default source type).

    Parameters:
      `namespaceID` - the namespace ID to search for symbols.
    Returns:
      symbol iterator

  - ### hasSymbol

    boolean hasSymbol(Address addr)
    Check if there exists any symbol at the given address
    Parameters:
      `addr` - address to check for an existing symbol
    Returns:
      true if any symbol exists

  - ### getDynamicSymbolID

    long getDynamicSymbolID(Address addr)
    Get the unique symbol ID for a dynamic symbol at the specified address

    Having a dynamic symbol ID does not imply that a dynamic symbol actually exists. Rather, this just gives the ID that a dynamic symbol at that address would have, should it ever exist.

    NOTE: This symbol ID should not be permanently stored since the encoding may change between software releases.

    Parameters:
      `addr` - the dynamic symbol memory address
    Returns:
      unique symbol ID
    Throws:
      `IllegalArgumentException` - if a non-memory address is specified

  - ### getSymbolIterator

    SymbolIterator getSymbolIterator(String searchStr, boolean caseSensitive)
    Get an iterator over all symbols that match the given query

    NOTE: The iterator is in the forward direction only and will not return default thunks (i.e., thunk function symbol with default source type).

    Parameters:
      `searchStr` - the query, which may contain * to match any sequence or ? to match a single char
      `caseSensitive` - flag to specify whether the search is case sensitive
    Returns:
      symbol iterator

  - ### getSymbols

    SymbolIterator getSymbols(AddressSetView addressSet, SymbolType type, boolean forward)
    Get all the symbols of the given type within the given address set.

    NOTE: All external symbols will be omiitted unless the full `AddressSpace.EXTERNAL_SPACE` range is included within the specified address set or a null addressSet is specified. All global dynamic label symbols will be omitted.

    Parameters:
      `addressSet` - the address set containing the symbols. A null value may be specified to include all memory and external primary symbols.
      `type` - the type of the symbols
      `forward` - the direction of the iterator, by address
    Returns:
      symbol iterator

  - ### scanSymbolsByName

    SymbolIterator scanSymbolsByName(String startName)
    Scan symbols lexicographically by name

    If a symbol with the given start name does not exist, the iterator will start at the first symbol following it. This includes only symbols whose addresses are in memory. In particular, it excludes external symbols and dynamic symbols, i.e., those generated as a reference destination.

    Parameters:
      `startName` - the starting point
    Returns:
      an iterator over the symbols in lexicographical order

  - ### getNumSymbols

    int getNumSymbols()
    Get the total number of symbols in the table
    Returns:
      total number of symbols

  - ### getSymbolIterator

    SymbolIterator getSymbolIterator()
    Get all label symbols

    Labels are defined on memory locations.

    Returns:
      symbol iterator

  - ### getDefinedSymbols

    SymbolIterator getDefinedSymbols()
    Get all defined symbols in no particular order. All global dynamic memory labels will be excluded.
    Returns:
      symbol iterator

  - ### getExternalSymbol

    Symbol getExternalSymbol(String name)
    Get the external symbol with the given name. The first occurrence of the named symbol found within any external namespace will be returned. If all matching symbols need to be considered the `getExternalSymbols(String)` should be used.
    Parameters:
      `name` - the name of the symbol
    Returns:
      the symbol, or null if no external symbol has that name

  - ### getExternalSymbols

    SymbolIterator getExternalSymbols(String name)
    Get all the external symbols with the given name
    Parameters:
      `name` - the name of symbols
    Returns:
      an iterator over the symbols

  - ### getExternalSymbols

    SymbolIterator getExternalSymbols()
    Get all defined external symbols in no particular order
    Returns:
      symbol iterator

  - ### getSymbolIterator

    SymbolIterator getSymbolIterator(boolean forward)
    Get all the symbols defined with program memory.

    NOTE: The returned symbols will not include any external symbols defined within the `AddressSpace.EXTERNAL_SPACE`. In addition, all global dynamic label symbols will be omitted.

    Parameters:
      `forward` - the direction of the iterator, by address
    Returns:
      symbol iterator

  - ### getSymbolIterator

    SymbolIterator getSymbolIterator(Address startAddr, boolean forward)
    Get all the symbols starting at the specified memory address.

    NOTE: The returned symbols will not include any external symbols defined within the `AddressSpace.EXTERNAL_SPACE`. In addition, all global dynamic label symbols will be omitted.

    Parameters:
      `startAddr` - the starting address
      `forward` - true means the iterator is in the forward direction
    Returns:
      symbol iterator
    Throws:
      `IllegalArgumentException` - if startAddr is not a memory address

  - ### getPrimarySymbolIterator

    SymbolIterator getPrimarySymbolIterator(boolean forward)
    Get all primary label and function symbols defined within program memory address. Iteration may span multiple memory spaces.

    NOTE: The returned symbols will not include any external symbols defined within the `AddressSpace.EXTERNAL_SPACE`. In addition, all global dynamic label symbols will be omitted.

    Parameters:
      `forward` - true means the iterator is in the forward direction
    Returns:
      symbol iterator

  - ### getPrimarySymbolIterator

    SymbolIterator getPrimarySymbolIterator(Address startAddr, boolean forward)
    Get all primary label and function symbols starting at the specified memory address through to the program's maximum memory address. Iteration may span multiple memory spaces.

    NOTE: The returned symbols will not include any external symbols defined within the `AddressSpace.EXTERNAL_SPACE`. In addition, all global dynamic label symbols will be omitted.

    Parameters:
      `startAddr` - the starting memory address
      `forward` - true means the iterator is in the forward direction
    Returns:
      symbol iterator
    Throws:
      `IllegalArgumentException` - if a non-memory address is specified

  - ### getPrimarySymbolIterator

    SymbolIterator getPrimarySymbolIterator(AddressSetView addressSet, boolean forward)
    Get primary label and function symbols within the given address set.

    NOTE: All external symbols will be omitted unless the full `AddressSpace.EXTERNAL_SPACE` range is included within the specified address set or a null addressSet is specified. All global dynamic label symbols will be omitted.

    Parameters:
      `addressSet` - the set of address containing the symbols. A null value may be specified to include all memory and external primary symbols.
      `forward` - true means the iterator is in the forward direction
    Returns:
      symbol iterator

  - ### addExternalEntryPoint

    void addExternalEntryPoint(Address addr)
    Add a memory address to the external entry points.
    Parameters:
      `addr` - the memory address to add
    Throws:
      `IllegalArgumentException` - if a non-memory is specified

  - ### removeExternalEntryPoint

    void removeExternalEntryPoint(Address addr)
    Remove an address from the external entry points
    Parameters:
      `addr` - the address to remove

  - ### isExternalEntryPoint

    boolean isExternalEntryPoint(Address addr)
    Check if the given address is an external entry point
    Parameters:
      `addr` - address to check
    Returns:
      true if specified address has been marked as an entry point, otherwise false

  - ### getExternalEntryPointIterator

    AddressIterator getExternalEntryPointIterator()
    Get the external entry points (addresses)
    Returns:
      entry-point address iterator

  - ### getLabelHistory

    LabelHistory[] getLabelHistory(Address addr)
    Get the label history for the given address

    Each entry records a change made to the labels at the given address

    Parameters:
      `addr` - address of the label change
    Returns:
      array of history objects

  - ### getLabelHistory

    Iterator<LabelHistory> getLabelHistory()
    Get the complete label history of the program
    Returns:
      an iterator over history entries

  - ### hasLabelHistory

    boolean hasLabelHistory(Address addr)
    Check if there is a history of label changes at the given address
    Parameters:
      `addr` - the address to check
    Returns:
      true if a label history exists for specified address, otherwise false

  - ### getNamespace

    Namespace getNamespace(Address addr)
    Get the deepest namespace containing the given address
    Parameters:
      `addr` - the address contained in the namespace
    Returns:
      the deepest namespace which contains the address

  - ### getClassNamespaces

    Iterator<GhidraClass> getClassNamespaces()
    Get all class namespaces defined within the program, in no particular order
    Returns:
      an iterator over the classes

  - ### createClass

    GhidraClass createClass(Namespace parent, String name, SourceType source) throws DuplicateNameException, InvalidInputException
    Create a class namespace in the given parent namespace
    Parameters:
      `parent` - the parent namespace, or null for the global namespace
      `name` - the name of the namespace
      `source` - the source of this class namespace's symbol
    Returns:
      the new class namespace
    Throws:
      `DuplicateNameException` - thrown if another non function or label symbol exists with the given name
      `InvalidInputException` - throw if the name has invalid characters or is null
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table or if source is `SourceType.DEFAULT`

  - ### getChildren

    SymbolIterator getChildren(Symbol parentSymbol)
    Get all symbols that have the given parent symbol

    NOTE: The resulting iterator will not return default thunks (i.e., thunk function symbol with default source type) or global dynamic label symbols.

    Parameters:
      `parentSymbol` - the parent symbol
    Returns:
      symbol iterator

  - ### createExternalLibrary

    Library createExternalLibrary(String name, SourceType source) throws DuplicateNameException, InvalidInputException
    Create a library namespace with the given name
    Parameters:
      `name` - the name of the new library namespace
      `source` - the source of this external library's symbol
    Returns:
      the new library namespace
    Throws:
      `InvalidInputException` - if the name is invalid
      `IllegalArgumentException` - if you try to set the source to `SourceType.DEFAULT`
      `DuplicateNameException` - thrown if another non function or label symbol exists with the given name

  - ### createNameSpace

    Namespace createNameSpace(Namespace parent, String name, SourceType source) throws DuplicateNameException, InvalidInputException
    Create a new namespace
    Parameters:
      `parent` - the parent of the new namespace, or null for the global namespace
      `name` - the name of the new namespace
      `source` - the source of this namespace's symbol
    Returns:
      the new namespace
    Throws:
      `DuplicateNameException` - if another non function or label symbol exists with the given name
      `InvalidInputException` - if the name is invalid
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table or if source is `SourceType.DEFAULT`

  - ### convertNamespaceToClass

    GhidraClass convertNamespaceToClass(Namespace namespace)
    Convert the given namespace to a class namespace
    Parameters:
      `namespace` - the namespace to convert
    Returns:
      the new class
    Throws:
      `ConcurrentModificationException` - if the given parent namespace has been deleted
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table or the namespace not allowed (e.g., global or library namespace).

  - ### getOrCreateNameSpace

    Namespace getOrCreateNameSpace(Namespace parent, String name, SourceType source) throws DuplicateNameException, InvalidInputException
    Get or create the namespace with the given name in the given parent

    If the namespace does not already exists, then it will be created.

    Parameters:
      `parent` - the parent namespace
      `name` - the namespace name
      `source` - the source type for the namespace if it is created
    Returns:
      the namespace
    Throws:
      `DuplicateNameException` - if another non function or label symbol exists with the given name
      `InvalidInputException` - if the name is invalid
      `IllegalArgumentException` - if the given parent namespace is from a different program than that of this symbol table
      `ConcurrentModificationException` - if the given parent namespace has been deleted